#ifndef _CLASS_IMPL_H
#define _CLASS_IMPL_H

#include "class_impl_def.h"
#include "class_.h"
#include "ot_impl.h"

#include "class_impl_inc.h"
#include "class_implMfields.h"
#include "any.h"
#include "sequence.h"

#include "runtime/C/dummy_class.h"
extern struct Class_s *class_impl_V;

#ifdef __cplusplus
extern "C" {
#endif

extern any class_implMcreate_simple_object(class_impl self);
extern void class_implMcompute_bitfields(class_impl self);
extern sequence class_implMtype_dv_template(class_impl self);
extern sequence class_implMclass_dv_template(class_impl self);
extern sequence class_implMcompute_dh_template(class_impl self);
extern sequence class_implMget_hidden_(class_impl self);
extern method class_implMget_method_(class_impl self, string mname);
extern void class_implMset_fields_(class_impl self, sequence fs);
extern class_implMfields_Iter_State class_implMfields_START_(class_impl self);
extern bool class_implMfields_LOOP_(class_impl self, class_implMfields_Iter_State IState);
extern class_ class_implMsuperclass_(class_impl self);
extern any class_implMcreate_simple_object_(class_impl self);
extern void class_implMcompute_bitfields_(class_impl self);
extern sequence class_implMtype_dv_template_(class_impl self);
extern sequence class_implMclass_dv_template_(class_impl self);
extern sequence class_implMcompute_dh_template_(class_impl self);

extern void Init_class_impl();

#ifdef __cplusplus
}
#endif


struct class_impl_class_DV {
  any (*create_simple_object)(class_impl self);
  void (*compute_bitfields)(class_impl self);
  sequence (*type_dv_template)(class_impl self);
  sequence (*class_dv_template)(class_impl self);
  sequence (*compute_dh_template)(class_impl self);
  bool (*get_is_complete)(ot_impl self);
  void (*add_new_method)(ot_impl self, method m);
  sequence (*method_sequence)(ot_impl self);
  sequence (*ot_implMtype_dv_template)(ot_impl self);
  sequence (*ot_implMclass_dv_template)(ot_impl self);
  sequence (*ot_implMcompute_dh_template)(ot_impl self);
  sequence (*merge_type_headers)(ot_impl self, sequence types);
  bool (*can_embed)(ot_impl self, Pval *__retvals, sequence dh1, sequence dh2);
  bool (*dv_match)(ot_impl self, sequence dv1, sequence dv2);
  sequence (*merge_template)(ot_impl self, sequence to_merge, sequence current, int offset);
  struct DV_hdr_s hdr;
  struct Class_s *(*get_class)(struct Obj_s *);
  string (*name)(meta_object self);
  int (*kind)(meta_object self);
  bool (*equal)(type_ self, type_ t);
  bool (*subtype_of)(type_ self, type_ t);
  type_Mmethods_Iter_State (*methods_START)(type_ self);
  int (*methods_LOOP)(type_ self, type_Mmethods_Iter_State IState);
  string (*unparse)(type_ self);
  method (*get_method)(type_ self, string name);
  int (*field_info)(type_ self, Pval *__retvals);
  sequence (*get_new_methods)(type_ self);
  void (*set_new_methods)(object_type self, sequence new_ms);
  void (*make_complete)(object_type self);
  object_typeMsupertypes_Iter_State (*supertypes_START)(object_type self);
  int (*supertypes_LOOP)(object_type self, object_typeMsupertypes_Iter_State IState);
  sequence (*supertypes_seq)(object_type self);
  object_typeMnew_methods_Iter_State (*new_methods_START)(object_type self);
  int (*new_methods_LOOP)(object_type self, object_typeMnew_methods_Iter_State IState);
  int (*dv_entry_size)(object_type self);
  int (*method_index)(object_type self, string name, object_type t);
  object_typeMmethod_renamings_Iter_State (*method_renamings_START)(object_type self, string name);
  int (*method_renamings_LOOP)(object_type self, object_typeMmethod_renamings_Iter_State IState);
  sequence (*get_renamings)(object_type self);
  sequence (*get_dh_template)(object_type self);
  sequence (*get_dv_template)(object_type self);
  class_Mfields_Iter_State (*fields_START)(class_ self);
  int (*fields_LOOP)(class_ self, class_Mfields_Iter_State IState);
  void (*set_fields)(class_ self, sequence new_fs);
  class_ (*superclass)(class_ self);
  sequence (*get_hidden)(class_ self);
};

struct class_impl_DV {
  struct DV_hdr_s hdr;
  struct Class_s *(*get_class)(struct Obj_s *);
  string (*name)(meta_object self);
  int (*kind)(meta_object self);
  bool (*equal)(type_ self, type_ t);
  bool (*subtype_of)(type_ self, type_ t);
  type_Mmethods_Iter_State (*methods_START)(type_ self);
  int (*methods_LOOP)(type_ self, type_Mmethods_Iter_State IState);
  string (*unparse)(type_ self);
  method (*get_method)(type_ self, string name);
  int (*field_info)(type_ self, Pval *__retvals);
  sequence (*get_new_methods)(type_ self);
  void (*set_new_methods)(object_type self, sequence new_ms);
  void (*make_complete)(object_type self);
  object_typeMsupertypes_Iter_State (*supertypes_START)(object_type self);
  int (*supertypes_LOOP)(object_type self, object_typeMsupertypes_Iter_State IState);
  sequence (*supertypes_seq)(object_type self);
  object_typeMnew_methods_Iter_State (*new_methods_START)(object_type self);
  int (*new_methods_LOOP)(object_type self, object_typeMnew_methods_Iter_State IState);
  int (*dv_entry_size)(object_type self);
  int (*method_index)(object_type self, string name, object_type t);
  object_typeMmethod_renamings_Iter_State (*method_renamings_START)(object_type self, string name);
  int (*method_renamings_LOOP)(object_type self, object_typeMmethod_renamings_Iter_State IState);
  sequence (*get_renamings)(object_type self);
  sequence (*get_dh_template)(object_type self);
  sequence (*get_dv_template)(object_type self);
  class_Mfields_Iter_State (*fields_START)(class_ self);
  int (*fields_LOOP)(class_ self, class_Mfields_Iter_State IState);
  void (*set_fields)(class_ self, sequence new_fs);
  class_ (*superclass)(class_ self);
  sequence (*get_hidden)(class_ self);
};

#include "ot_impl.h"

#include "maybe.h"
#include "string.h"
#include "sequence.h"
#include "int.h"
#include "bool.h"

struct class_impl_f_s {
  struct ot_impl_f_s  inh;
  Shortp fields_;
  Shortp superclass_;
  Shortp bitfields;
  int slots;
  int dhsize;
  th_bool repeating_slots;
  Shortp hidden_methods_;
  th_bool special;
  Shortp specialtext;
};


#endif /* _CLASS_IMPL_H */
