#ifndef _PCLASS_IMPL_H
#define _PCLASS_IMPL_H

#include "pclass_impl_def.h"
#include "pclass.h"
#include "ptype_impl.h"

#include "pclass_impl_inc.h"

#include "runtime/C/dummy_class.h"
extern struct Class_s *pclass_impl_V;

#ifdef __cplusplus
extern "C" {
#endif

extern sequence pclass_implMfields_(pclass_impl self);
extern class_ pclass_implMsuperclass_(pclass_impl self);

extern void Init_pclass_impl();

#ifdef __cplusplus
}
#endif


struct pclass_impl_class_DV {
  ptype_implMwhere_clauses_Iter_State (*where_clauses_START)(ptype_impl self);
  int (*where_clauses_LOOP)(ptype_impl self, ptype_implMwhere_clauses_Iter_State IState);
  bool (*get_is_complete)(ot_impl self);
  sequence (*supertypes_seq)(ot_impl self);
  sequence (*get_new_methods)(ot_impl self);
  sequence (*get_renamings)(ot_impl self);
  bool (*equal)(ot_impl self, type_ t);
  void (*make_complete)(ot_impl self);
  void (*set_new_methods)(ot_impl self, sequence new_ms);
  void (*add_new_method)(ot_impl self, method m);
  bool (*subtype_of)(ot_impl self, type_ t);
  method (*get_method)(ot_impl self, string mname);
  ot_implMmethod_renamings_Iter_State (*method_renamings_START)(ot_impl self, string mname);
  int (*method_renamings_LOOP)(ot_impl self, ot_implMmethod_renamings_Iter_State IState);
  sequence (*method_sequence)(ot_impl self);
  sequence (*type_dv_template)(ot_impl self);
  sequence (*class_dv_template)(ot_impl self);
  int (*method_index)(ot_impl self, string n, object_type t);
  int (*field_info)(ot_impl self, Pval *__retvals);
  ot_implMnew_methods_Iter_State (*new_methods_START)(ot_impl self);
  int (*new_methods_LOOP)(ot_impl self, ot_implMnew_methods_Iter_State IState);
  int (*dv_entry_size)(ot_impl self);
  sequence (*get_dv_template)(ot_impl self);
  sequence (*get_dh_template)(ot_impl self);
  sequence (*compute_dh_template)(ot_impl self);
  sequence (*merge_type_headers)(ot_impl self, sequence types);
  bool (*can_embed)(ot_impl self, Pval *__retvals, sequence dh1, sequence dh2);
  bool (*dv_match)(ot_impl self, sequence dv1, sequence dv2);
  sequence (*merge_template)(ot_impl self, sequence to_merge, sequence current, int offset);
  struct DV_hdr_s hdr;
  struct Class_s *(*get_class)(struct Obj_s *);
  string (*name)(meta_object self);
  int (*kind)(meta_object self);
  bool (*pt_equal)(ptype self, ptype pt);
  ptypeMsupertypes_Iter_State (*supertypes_START)(ptype self);
  int (*supertypes_LOOP)(ptype self, ptypeMsupertypes_Iter_State IState);
  instn (*instantiate)(ptype self, sequence args);
  ptypeMparameters_Iter_State (*parameters_START)(ptype self);
  int (*parameters_LOOP)(ptype self, ptypeMparameters_Iter_State IState);
  ptypeMmethods_Iter_State (*methods_START)(ptype self);
  int (*methods_LOOP)(ptype self, ptypeMmethods_Iter_State IState);
  string (*unparse)(ptype self);
  class_ (*superclass)(pclass self);
  sequence (*fields)(pclass self);
};

struct pclass_impl_DV {
  struct DV_hdr_s hdr;
  struct Class_s *(*get_class)(struct Obj_s *);
  string (*name)(meta_object self);
  int (*kind)(meta_object self);
  bool (*pt_equal)(ptype self, ptype pt);
  ptypeMsupertypes_Iter_State (*supertypes_START)(ptype self);
  int (*supertypes_LOOP)(ptype self, ptypeMsupertypes_Iter_State IState);
  instn (*instantiate)(ptype self, sequence args);
  ptypeMparameters_Iter_State (*parameters_START)(ptype self);
  int (*parameters_LOOP)(ptype self, ptypeMparameters_Iter_State IState);
  ptypeMmethods_Iter_State (*methods_START)(ptype self);
  int (*methods_LOOP)(ptype self, ptypeMmethods_Iter_State IState);
  string (*unparse)(ptype self);
  class_ (*superclass)(pclass self);
  sequence (*fields)(pclass self);
};

#include "ptype_impl.h"

#include "maybe.h"
#include "sequence.h"

struct pclass_impl_f_s {
  struct ptype_impl_f_s  inh;
  Shortp superclass_;
  Shortp fields_;
};


#endif /* _PCLASS_IMPL_H */
