#ifndef _PMETHOD_H
#define _PMETHOD_H

#include "pmethod_def.h"
#include "method.h"
#include "param.h"
#include "sequence.h"
#include "minstn.h"

#include "runtime/C/dummy_class.h"
extern struct Objtype_s *pmethod_V;

struct pmethodMparameters_Iter_State_s {
int pc;
int spare;
param ret_0;
};

#ifdef __cplusplus
extern "C" {
#endif

extern minstn pmethodMinstantiate(pmethod self, sequence args);
extern pmethodMparameters_Iter_State pmethodMparameters_START_(pmethod self);
extern bool pmethodMparameters_LOOP_(pmethod self, pmethodMparameters_Iter_State IState);

extern void Init_pmethod();

#ifdef __cplusplus
}
#endif


struct pmethod_DV {
  struct DV_hdr_s hdr;
  struct Class_s *(*get_class)(struct Obj_s *);
  bool (*equal)(method self, method m2);
  bool (*similar)(method self, method m2);
  sequence (*get_args)(method self);
  sequence (*get_returns)(method self);
  sequence (*get_signals)(method self);
  methodMarguments_Iter_State (*arguments_START)(method self);
  int (*arguments_LOOP)(method self, methodMarguments_Iter_State IState);
  formal (*fetch_argument)(method self, int i);
  int (*num_arguments)(method self);
  methodMsignals__Iter_State (*signals__START)(method self);
  int (*signals__LOOP)(method self, methodMsignals__Iter_State IState);
  signal_ (*fetch_signal)(method self, int i);
  int (*num_signals)(method self);
  methodMreturns__Iter_State (*returns__START)(method self);
  int (*returns__LOOP)(method self, methodMreturns__Iter_State IState);
  type_ (*fetch_return)(method self, int i);
  int (*num_returns)(method self);
  string (*name)(method self);
  string (*unparse)(method self);
  method (*rename)(method self, string new_name);
  bool (*is_iter)(method self);
  bool (*is_parameterized)(method self);
  minstn (*instantiate)(pmethod self, sequence args);
  pmethodMparameters_Iter_State (*parameters_START)(pmethod self);
  int (*parameters_LOOP)(pmethod self, pmethodMparameters_Iter_State IState);
};

#endif /* _PMETHOD_H */
