#ifndef _PMETHOD_IMPL_H
#define _PMETHOD_IMPL_H

#include "pmethod_impl_def.h"
#include "pmethod.h"
#include "method_impl.h"

#include "pmethod_impl_inc.h"
#include "pmethod_implMparameters.h"

#include "runtime/C/dummy_class.h"
extern struct Class_s *pmethod_impl_V;

#ifdef __cplusplus
extern "C" {
#endif

extern minstn pmethod_implMinstantiate_(pmethod_impl self, sequence args);
extern pmethod_implMparameters_Iter_State pmethod_implMparameters_START_(pmethod_impl self);
extern bool pmethod_implMparameters_LOOP_(pmethod_impl self, pmethod_implMparameters_Iter_State IState);

extern void Init_pmethod_impl();

#ifdef __cplusplus
}
#endif


struct pmethod_impl_class_DV {
  bool (*parameterized)(method_impl self);
  struct DV_hdr_s hdr;
  struct Class_s *(*get_class)(struct Obj_s *);
  bool (*equal)(method self, method m2);
  bool (*similar)(method self, method m2);
  sequence (*get_args)(method self);
  sequence (*get_returns)(method self);
  sequence (*get_signals)(method self);
  methodMarguments_Iter_State (*arguments_START)(method self);
  int (*arguments_LOOP)(method self, methodMarguments_Iter_State IState);
  formal (*fetch_argument)(method self, int i);
  int (*num_arguments)(method self);
  methodMsignals__Iter_State (*signals__START)(method self);
  int (*signals__LOOP)(method self, methodMsignals__Iter_State IState);
  signal_ (*fetch_signal)(method self, int i);
  int (*num_signals)(method self);
  methodMreturns__Iter_State (*returns__START)(method self);
  int (*returns__LOOP)(method self, methodMreturns__Iter_State IState);
  type_ (*fetch_return)(method self, int i);
  int (*num_returns)(method self);
  string (*name)(method self);
  string (*unparse)(method self);
  method (*rename)(method self, string new_name);
  bool (*is_iter)(method self);
  bool (*is_parameterized)(method self);
  minstn (*instantiate)(pmethod self, sequence args);
  pmethodMparameters_Iter_State (*parameters_START)(pmethod self);
  int (*parameters_LOOP)(pmethod self, pmethodMparameters_Iter_State IState);
};

struct pmethod_impl_DV {
  struct DV_hdr_s hdr;
  struct Class_s *(*get_class)(struct Obj_s *);
  bool (*equal)(method self, method m2);
  bool (*similar)(method self, method m2);
  sequence (*get_args)(method self);
  sequence (*get_returns)(method self);
  sequence (*get_signals)(method self);
  methodMarguments_Iter_State (*arguments_START)(method self);
  int (*arguments_LOOP)(method self, methodMarguments_Iter_State IState);
  formal (*fetch_argument)(method self, int i);
  int (*num_arguments)(method self);
  methodMsignals__Iter_State (*signals__START)(method self);
  int (*signals__LOOP)(method self, methodMsignals__Iter_State IState);
  signal_ (*fetch_signal)(method self, int i);
  int (*num_signals)(method self);
  methodMreturns__Iter_State (*returns__START)(method self);
  int (*returns__LOOP)(method self, methodMreturns__Iter_State IState);
  type_ (*fetch_return)(method self, int i);
  int (*num_returns)(method self);
  string (*name)(method self);
  string (*unparse)(method self);
  method (*rename)(method self, string new_name);
  bool (*is_iter)(method self);
  bool (*is_parameterized)(method self);
  minstn (*instantiate)(pmethod self, sequence args);
  pmethodMparameters_Iter_State (*parameters_START)(pmethod self);
  int (*parameters_LOOP)(pmethod self, pmethodMparameters_Iter_State IState);
};

#include "method_impl.h"

#include "ptype.h"

struct pmethod_impl_f_s {
  struct method_impl_f_s  inh;
  Shortp pt;
};


#endif /* _PMETHOD_IMPL_H */
