// Copyright 1995 Barbara Liskov

#ifndef _CG_H
#define _CG_H
extern "C" {
enum iter_type {INT_TO = 1, INT_TO_BY, ARRAY_ELTS, ARRAY_INDX,
                VECTOR_ELTS, VECTOR_INDX, SEQUENCE_ELTS, SEQUENCE_INDX};
bool opt_inv(Invoc *inv, iter_type *which);

extern void do_type_file(string filename, string tname, 
			objtype t, ParseNode *pn);
extern void begin_class_file(string filename, string tname, 
			string cname, objtype t, ParseNode *pn);
extern void end_class_file();
extern void begin_rtn_file(string filename, ParseNode *pn, string nm,
			method m);
extern void end_rtn_file();
extern void begin_support_files(string nm);
extern void extend_support_files(ParseNode *pn);
extern void end_support_files();
extern void ps(char *s);
extern void psc(const char *s);
extern void pstr(string s);
extern void pstrup(string s);
extern void pint(int i);
extern void phex(int i);
extern void ptname();
extern void pcname();
extern void prname();
extern void pftname(type t);
extern void popt();
extern void pmsig(method m);
extern void prsig(method m);
extern void pmkrsig(method m);
extern bool is_ivar(Expr *prim, string nm, const char **c_name);
extern bool is_ivar_1(Expr *prim, string nm, string *c_name);
extern bool is_method(string nm);
extern Decl *find_ivar_in_dl(string m_name, ParseNodeList *dl);
extern objtype the_obj;
extern class_ save_stripped_class;
extern void save_class(ClassDef *cd);
extern void clear_class();
extern ClassDef *get_save_class();
extern void save_rdef(RoutineDef *rdef);
extern void clear_rdef();
extern string current_return_type();
extern void srch_pn_for_types(ParseNode *pn);
extern void clear_types();
extern void output_types();
extern void output_pts_externs();
extern void output_pts_decls();
extern void output_pts_data();
extern void output_pts_instns();
extern void clear_pts();
extern void clear_global_pts();
extern void decl_temps(ParseNode *pn);
extern void decl_locals(ParseNode *pn);
extern void srch_pnl_for_locals(ParseNodeList *pnl);
extern void srch_pn_for_locals(ParseNode *pn);
extern void srch_pnl_for_temps(ParseNodeList *pnl);
extern void srch_pn_for_temps(ParseNode *pn);
extern void process_locals(TypeSpec *ts, ParseNodeList *pnl);
extern void process_local(TypeSpec *ts, Id *id);
extern void process_temps(ParseNodeList *pnl);
extern void process_temp(Expr *ex);
extern bool simple_expr(Expr *ex);
extern void save_local(string typ, string id);
extern void clear_locals();
extern void output_locals();
extern void output_local(string typ, string id);
extern void save_temp(string typ);
extern void clear_temps();
extern void reset_temps();
extern void output_temps();
extern void output_temp(string typ, char *id);
extern string get_next_temp();
extern string get_next_temp_and_type(string *types_name);
extern string simple_type_name(string type_name);
extern ParseNodeList *exprs_preprocess(ParseNodeList *exl);
extern Expr *expr_preprocess(Expr *ex);
extern void eq_clear();
extern void eq_emit(Equate *eq);
extern void eq_save(Equate *eq);
extern void eq_emit_saved();
extern void expr_emit(Expr *ex);
extern void exprs_emit(ParseNodeList *exl);
extern ParseNode *inv_preprocess(Invoc *inv);
extern void pn_emit(ParseNode *inv);
extern void inv_emit(Invoc *inv, string mkslfst, string mkslfnm);
extern void inv_check_emit(Invoc *inv);
extern void pn_check_emit(ParseNode *pn);
extern bool base_inv_emit(Invoc *inv, DotExpr *de, bool parmd_result, int pass);
extern void decls_emit(ParseNodeList *decls);
extern void decl_emit(Decl *decl);
extern void idorivar_emit(IdOrIvar *idv);
extern void inc_ind();
extern void dec_ind();
extern void ind();
extern void loop_init();
extern void loop_enter();
extern void loop_end_label();
extern void  loop_goto_end();
extern void loop_exit();
extern void exc_init();
extern void exc_enter();
extern void exc_exit();
extern int  exc_current();
extern void exc_label();
extern void exc_end_label();
extern void exc_goto_end();
extern void exc_goto_exc(bool tab);
extern bool exc_scope_exists();
extern bool inv_signalling(Invoc *inv, type *tp);
extern bool inv_parmd(method m);
extern bool inv_result_parmd(ParseNode *pn);
extern bool parmd_site();
extern ptype instn_ptype(instn);
extern instn type_as_instn(type);
extern void fix_fix(DotExpr *de);
extern void fix_read(string nm, type t, char *c_name);
extern void fix_read_1(Expr *ex);
extern void fix_write(ParseNode *pn);
extern void fix_write_1(ParseNode *pn);
extern void fix_clear();
extern void fix_new_scope();
extern void fix_end_scope();
extern objtype stripped_class(objtype ot);
extern void do_supersc(objtype ot, char *ditty);
extern bool anyize(ParseNode *pn, type t);
extern bool anyize_it(type t);
extern bool assn_cast_site(ParseNode *lpn, type t);
extern bool is_object(type t);
extern bool cg_rhs;
extern type get_one_type(TypeInterface *ti, int lineno);
extern type get_first_type(TypeInterface *ti, int lineno);
extern string type2nm(type t);
extern const char *find_class_that_defines_method(method m);
extern void mod_impls_save(ImplModule *im);
extern void mod_impls_clear();
extern bool mod_impls_member(RoutineDef *rd);
extern void do_closing(RoutineDef *rd);
extern void opt_inv_temps(Invoc *inv);
extern bool opt_declforstmt(DeclForStmt *dfs);
extern bool opt_forstmt(ForStmt *fs);
extern bool forced_prep();
extern void enter_forced_prep();
extern void leave_forced_prep();
extern char *type2discr(type t);
extern type get_nth_return_type(int nth);
extern void init_emit(bool castit, string cname, string supername, string objname, ParseNodeList *fields, Invoc *inv);
extern void init_emit_1(bool castit, string cname, string supername, string objname, ParseNodeList *fields, Invoc *inv);


}
extern void do_type_file_1(string filename, string Tname, objtype t, ParseNode *pn);
extern void begin_class_file_1(string filename, string Tname,
		string cname, objtype t, ParseNode *pn);
extern void begin_rtn_file_1(string filename, ParseNode *pn, string nm, method m);
extern void pmsig_1(method m);
extern void prsig_1(method m);
extern void pmkrsig_1(method m);
extern void pitersig_1(method m, RoutineDef *rd);
extern void do_supersc_1(objtype ot, char *ditty);
extern void end_class_file_1();
extern void end_rtn_file_1();
extern void end_mkr_file_1();
extern void begin_support_files_1(string nm);
extern void extend_support_files_1(ParseNode *pn);
extern void end_support_files_1();
extern bool is_vtype(type t);
extern bool is_vtypestr(string tnm);
extern int get_yields();
extern int get_next_yield();
extern bool get_iter_active();
extern void set_iter_active();
extern void clear_iter_active();
#endif /* _CG_H */
