// Copyright 1995 Barbara Liskov

#ifndef _DESUGAR_H
#define _DESUGAR_H

#include "traverse.h"

/*----------------------------------------------------------------

     A DesugarObj is a type of TraverseObj, who's xmogrify method
     when invoked on a ParseNode, returns a new ParseNode in which all
     unary and binary expressions have been desugared into method
     invocations;  DesugarObj::xmogrify also desugars array references
     into method invocations.
    
----------------------------------------------------------------*/
    
class DesugarObj : public TraverseObj {

  public: 
    DesugarObj() {}
    ParseNode* xmogrify(ParseNode *pn);
    ParseNode* setup(ParseNode *pn);
};

#endif /* _DESUGAR_H */




